HDU 4336 Card Collector(动态规划-概率DP)

简介:

Card Collector

Problem Description
In your childhood, do you crazy for collecting the beautiful cards in the snacks? They said that, for example, if you collect all the 108 people in the famous novel Water Margin, you will win an amazing award. 

As a smart boy, you notice that to win the award, you must buy much more snacks than it seems to be. To convince your friends not to waste money any more, you should find the expected number of snacks one should buy to collect a full suit of cards.
 

Input
The first line of each test case contains one integer N (1 <= N <= 20), indicating the number of different cards you need the collect. The second line contains N numbers p1, p2, ..., pN, (p1 + p2 + ... + pN <= 1), indicating the possibility of each card to appear in a bag of snacks. 

Note there is at most one card in a bag of snacks. And it is possible that there is nothing in the bag.
 

Output
Output one number for each test case, indicating the expected number of bags to buy to collect all the N different cards.

You will get accepted if the difference between your answer and the standard answer is no more that 10^-4.
 

Sample Input
 
 
1 0.1 2 0.1 0.4
 

Sample Output
 
 
10.000 10.500
 

Source
 

Recommend
zhoujiaqi2010
 

题目大意:

有n个卡片,你如今买一包方便面,没包方便面出现当中一个卡片的概率为 p[i] 。问你集齐一套卡片须要的张数的数学期望。


解题思路:

概率DP,用位进制0表示这个卡片有了,1表示这个卡片还没有。那么 比如 “3” 用二进制表示 “1 1” 那么 数组 dp[3] 记录的就是 1号卡片和2号卡片都有的情况集齐一套卡片须要的张数的数学期望。

dp[sum]= ( 1+sum { dp[ sum + (1<<j )] *p[j] }   ) /sum{p[j] }

当中 ( i&(1<<j) )==0


解题代码:

#include <iostream>
#include <cstdio>
using namespace std;

const int maxn=(1<<20)+10;
int n;
double dp[maxn];
double p[30];

void solve(){
    int sum=(1<<n)-1;
    dp[sum]=0;
    for(int i=sum-1;i>=0;i--){
        double tmp=0;
        dp[i]=1;
        for(int j=0;j<n;j++){
            if( ( i&(1<<j) )==0 ){
                dp[i]+=dp[i+(1<<j)]*p[j];
                tmp+=p[j];
            }
        }
        dp[i]/=tmp;
    }
    printf("%lf\n",dp[0]);
}

int main(){
    while(scanf("%d",&n)!=EOF){
        for(int i=0;i<n;i++) scanf("%lf",&p[i]);
        solve();
    }
    return 0;
}



本文转自mfrbuaa博客园博客,原文链接:http://www.cnblogs.com/mfrbuaa/p/5167129.html,如需转载请自行联系原作者

相关文章
|
6月前
|
机器学习/深度学习 Java
hdu-2680-Choose the best route(dijkstra)
hdu-2680-Choose the best route(dijkstra)
29 0
|
6月前
|
C++
HDU2319— Card Trick
HDU2319— Card Trick
|
开发框架 .NET
poj 3468 A Simple Problem with Integers线段树区间修改
题目意思很简单,有N个数,Q个操作, Q l r 表示查询从l到r 的和,C l r v 表示将从l到r 的值加上v,明显的线段树,不知道线段树的人肯定暴力,肯定超时,哈哈!!
30 0
|
算法
light oj 1047 - Neighbor House 动态规划
动态规划,这个和刘汝佳算法竞赛入门经典P158的数字三角形有些相似,不过是求最小的值,而且有些限制,每次走到点和上次走的点不在同一列。
28 0
|
机器学习/深度学习 人工智能 BI
The Great Hero(Codeforces Round #700 (Div. 2))模拟+贪心思想和排序
The Great Hero(Codeforces Round #700 (Div. 2))模拟+贪心思想和排序
60 0
HDU-2602,Bone Collector(01背包)
HDU-2602,Bone Collector(01背包)
|
机器学习/深度学习
HDU-2680,Choose the best route(Dijkstra)
HDU-2680,Choose the best route(Dijkstra)
HDOJ 1339 A Simple Task(简单数学题,暴力)
HDOJ 1339 A Simple Task(简单数学题,暴力)
113 0